Index: /trunk/kBuild/footer.kmk
===================================================================
--- /trunk/kBuild/footer.kmk	(revision 1647)
+++ /trunk/kBuild/footer.kmk	(revision 1648)
@@ -1357,5 +1357,5 @@
 tool_prefix := LD
 bld_trg_base_var := PLATFORM
-$(foreach target, $(BLDPROGS) $(BLDPROGS.$(KBUILD_HOST)) $(BLDPROGS.$(KBUILD_HOST).$(KBUILD_HOST_ARCH)), \
+$(foreach target, $(_ALL_BLDPROGS), \
 	$(evalval def_pass1_bldprog))
 
@@ -1369,5 +1369,5 @@
 tool_prefix := AR
 bld_trg_base_var := TARGET
-$(foreach target, $(LIBRARIES) $(LIBRARIES.$(KBUILD_TARGET)) $(LIBRARIES.$(KBUILD_TARGET).$(KBUILD_TARGET_ARCH)), \
+$(foreach target, $(_ALL_LIBRARIES), \
 	$(evalval def_pass1_link_common))
 
@@ -1381,5 +1381,5 @@
 tool_prefix := LD
 bld_trg_base_var := TARGET
-$(foreach target, $(DLLS) $(DLLS.$(KBUILD_TARGET)) $(DLLS.$(KBUILD_TARGET).$(KBUILD_TARGET_ARCH)), \
+$(foreach target, $(_ALL_DLLS), \
 	$(evalval def_pass1_link_common))
 
@@ -1397,5 +1397,5 @@
  tool_prefix := AR
  bld_trg_base_var := TARGET
- $(foreach target, $(IMPORT_LIBS) $(IMPORT_LIBS.$(KBUILD_TARGET)) $(IMPORT_LIBS.$(KBUILD_TARGET).$(KBUILD_TARGET_ARCH)), \
+ $(foreach target, $(_ALL_IMPORT_LIBS), \
 	$(evalval def_pass1_link_common))
 else
@@ -1405,5 +1405,5 @@
  tool_prefix := LD
  bld_trg_base_var := TARGET
- $(foreach target, $(IMPORT_LIBS) $(IMPORT_LIBS.$(KBUILD_TARGET)) $(IMPORT_LIBS.$(KBUILD_TARGET).$(KBUILD_TARGET_ARCH)), \
+ $(foreach target, $(_ALL_IMPORT_LIBS), \
 	$(evalval def_pass1_link_common))
 endif
@@ -1418,5 +1418,5 @@
 tool_prefix := LD
 bld_trg_base_var := TARGET
-$(foreach target, $(PROGRAMS) $(PROGRAMS.$(KBUILD_TARGET)) $(PROGRAMS.$(KBUILD_TARGET).$(KBUILD_TARGET_ARCH)), \
+$(foreach target, $(_ALL_PROGRAMS), \
 	$(evalval def_pass1_link_common))
 
@@ -1430,5 +1430,5 @@
 tool_prefix := LD
 bld_trg_base_var := TARGET
-$(foreach target, $(SYSMODS) $(SYSMODS.$(KBUILD_TARGET)) $(SYSMODS.$(KBUILD_TARGET).$(KBUILD_TARGET_ARCH)), \
+$(foreach target, $(_ALL_SYSMODS), \
 	$(evalval def_pass1_link_common))
 
@@ -1447,5 +1447,5 @@
 # INSTARGET_ later.
 endef
-$(foreach target, $(INSTALLS) $(INSTALLS.$(KBUILD_TARGET)) $(INSTALLS.$(KBUILD_TARGET).$(KBUILD_TARGET_ARCH)), \
+$(foreach target, $(_ALL_INSTALLS), \
 	$(evalval def_pass1_install))
 
@@ -1840,5 +1840,5 @@
 bld_trg := $(KBUILD_TARGET)
 bld_trg_arch := $(KBUILD_TARGET_ARCH)
-$(foreach target, $(FETCHES) $(FETCHES.$(KBUILD_TARGET)) $(FETCHES.$(KBUILD_TARGET).$(KBUILD_TARGET_ARCH)), \
+$(foreach target, $(_ALL_FETCHES), \
 	$(evalvalctx def_fetch))
 
@@ -1876,5 +1876,5 @@
 #endef
 #
-#$(foreach target, $(PATCHES) $(PATCHES.$(KBUILD_TARGET)) $(PATCHES.$(KBUILD_TARGET).$(KBUILD_TARGET_ARCH)), \
+#$(foreach target, $(_ALL_PATCHES), \
 #	$(evalval def_patch))
 #
@@ -2302,5 +2302,5 @@
 tool_do := LINK_LIBRARY
 mode := 0644
-$(foreach target, $(LIBRARIES) $(LIBRARIES.$(KBUILD_TARGET)) $(LIBRARIES.$(KBUILD_TARGET).$(KBUILD_TARGET_ARCH)), $(evalval def_lib))
+$(foreach target, $(_ALL_LIBRARIES), $(evalval def_lib))
 
 ifdef KBUILD_PROFILE_SELF
@@ -2668,5 +2668,5 @@
 mode    := 0755
 bld_trg_base_var := PLATFORM
-$(foreach target, $(BLDPROGS) $(BLDPROGS.$(KBUILD_HOST)) $(BLDPROGS.$(KBUILD_HOST).$(KBUILD_HOST_ARCH)), $(evalval def_bldprog))
+$(foreach target, $(_ALL_BLDPROGS), $(evalval def_bldprog))
 
 ifdef KBUILD_PROFILE_SELF
@@ -2690,5 +2690,5 @@
 mode    := 0644
 bld_trg_base_var := TARGET
-$(foreach target, $(DLLS) $(DLLS.$(KBUILD_TARGET)) $(DLLS.$(KBUILD_TARGET).$(KBUILD_TARGET_ARCH)), $(evalval def_link_common))
+$(foreach target, $(_ALL_DLLS), $(evalval def_link_common))
 
 ifdef KBUILD_PROFILE_SELF
@@ -2714,10 +2714,10 @@
  tool_do := LINK_LIBRARY
  definst := $(PATH_LIB)
- $(foreach target, $(IMPORT_LIBS) $(IMPORT_LIBS.$(KBUILD_TARGET)) $(IMPORT_LIBS.$(KBUILD_TARGET).$(KBUILD_TARGET_ARCH)), $(evalval def_lib))
+ $(foreach target, $(_ALL_IMPORT_LIBS), $(evalval def_lib))
 else
  EXT     := DLL
  tool_do := LINK_DLL
  definst := $(PATH_DLL)
- $(foreach target, $(IMPORT_LIBS) $(IMPORT_LIBS.$(KBUILD_TARGET)) $(IMPORT_LIBS.$(KBUILD_TARGET).$(KBUILD_TARGET_ARCH)), $(evalval def_link_common))
+ $(foreach target, $(_ALL_IMPORT_LIBS), $(evalval def_link_common))
 endif
 
@@ -2742,5 +2742,5 @@
 mode    := 0755
 bld_trg_base_var := TARGET
-$(foreach target, $(PROGRAMS) $(PROGRAMS.$(KBUILD_TARGET)) $(PROGRAMS.$(KBUILD_TARGET).$(KBUILD_TARGET_ARCH)), $(evalval def_link_common))
+$(foreach target, $(_ALL_PROGRAMS), $(evalval def_link_common))
 
 ifdef KBUILD_PROFILE_SELF
@@ -2764,5 +2764,5 @@
 mode    := 0644
 bld_trg_base_var := TARGET
-$(foreach target, $(SYSMODS) $(SYSMODS.$(KBUILD_TARGET)) $(SYSMODS.$(KBUILD_TARGET).$(KBUILD_TARGET_ARCH)), $(evalval def_link_common))
+$(foreach target, $(_ALL_SYSMODS), $(evalval def_link_common))
 
 ifdef KBUILD_PROFILE_SELF
@@ -3091,5 +3091,5 @@
 
 ## process all install targets
-$(foreach target, $(INSTALLS) $(INSTALLS.$(KBUILD_TARGET)) $(INSTALLS.$(KBUILD_TARGET).$(KBUILD_TARGET_ARCH)), \
+$(foreach target, $(_ALL_INSTALLS), \
 	$(evalvalctx def_install))
 