Index: /trunk/src/VBox/Frontends/VirtualBox/src/VBoxGlobal.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/VBoxGlobal.cpp	(revision 1700)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/VBoxGlobal.cpp	(revision 1701)
@@ -1000,9 +1000,14 @@
                 {
                     CEnums::NetworkAttachmentType type = adapter.GetAttachmentType();
-                    QString attType = vboxGlobal().toString (type);
+                    QString attType;
+                    /* don't use the adapter type string for types that have
+                     * an additional symbolic network/interface name field, use
+                     * this name instead */
                     if (type == CEnums::HostInterfaceNetworkAttachment)
-                        attType += " \"" + adapter.GetHostInterface() + "\"";
-                    if (type == CEnums::InternalNetworkAttachment)
-                        attType += " \"" + adapter.GetInternalNetwork() + "\"";
+                        attType = adapter.GetHostInterface();
+                    else if (type == CEnums::InternalNetworkAttachment)
+                        attType = adapter.GetInternalNetwork();
+                    else
+                        attType = vboxGlobal().toString (type);
 
                     item += QString (sSectionItemTpl)
Index: /trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMNetworkSettings.ui
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMNetworkSettings.ui	(revision 1700)
+++ /trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMNetworkSettings.ui	(revision 1701)
@@ -54,5 +54,9 @@
             </property>
             <property name="title">
-                <string>&amp;Enable Network Adapter (plug it into the corresponding slot)</string>
+                <string>&amp;Enable Network Adapter</string>
+            </property>
+            <property name="whatsThis" stdset="0">
+                <string>When checked, plugs this virtual network adapter into
+                the virtual machine.</string>
             </property>
             <property name="checkable">
@@ -103,5 +107,7 @@
                                     </property>
                                     <property name="whatsThis" stdset="0">
-                                        <string>Type of network attachment.</string>
+                                        <string>Controls the way how this
+                                        virtual adapter is attached to the
+                                        real network of the Host OS.</string>
                                     </property>
                                 </widget>
@@ -146,5 +152,8 @@
                                     </property>
                                     <property name="whatsThis" stdset="0">
-                                        <string>MAC address of the current adapter. It contains exactly 12 characters choosen from {0-9,A-F}.</string>
+                                        <string>Displays the MAC address of
+                                        this adapter. It contains exactly 12
+                                        characters chosen from
+                                        {0-9,A-F}.</string>
                                     </property>
                                 </widget>
@@ -190,5 +199,5 @@
                                     </property>
                                     <property name="whatsThis" stdset="0">
-                                        <string>Generate a new random MAC address.</string>
+                                        <string>Generates a new random MAC address.</string>
                                     </property>
                                 </widget>
@@ -208,5 +217,6 @@
                     </property>
                     <property name="whatsThis" stdset="0">
-                        <string>This controls whether the virtual network cable is plugged in.</string>
+                        <string>Indicates whether the virtual network cable is plugged
+                        in on machine startup or not.</string>
                     </property>
                 </widget>
@@ -294,5 +304,8 @@
                                                     </property>
                                                     <property name="whatsThis" stdset="0">
-                                                        <string>The name of the interface selected for the current adapter</string>
+                                                        <string>Displays the
+                                                        name of the host
+                                                        interface selected for
+                                                        this adapter.</string>
                                                     </property>
                                                 </widget>
@@ -312,5 +325,6 @@
                                             </property>
                                             <property name="whatsThis" stdset="0">
-                                                <string>The list of interfaces available</string>
+                                                <string>Lists all available
+                                                host interfaces.</string>
                                             </property>
                                         </widget>
@@ -346,5 +360,5 @@
                                                     </property>
                                                     <property name="whatsThis" stdset="0">
-                                                        <string>Add a new host interface</string>
+                                                        <string>Adds a new host interface.</string>
                                                     </property>
                                                 </widget>
@@ -366,6 +380,6 @@
                                                     </property>
                                                     <property name="whatsThis" stdset="0">
-                                                        <string>Remove
-                                                        the selected host interface</string>
+                                                        <string>Removes
+                                                        the selected host interface.</string>
                                                     </property>
                                                 </widget>
@@ -457,5 +471,7 @@
                                                     </property>
                                                     <property name="whatsThis" stdset="0">
-                                                        <string>TAP interface name</string>
+                                                        <string>Displays the
+                                                        TAP interface
+                                                        name.</string>
                                                     </property>
                                                 </widget>
@@ -597,5 +613,8 @@
                                                     </property>
                                                     <property name="whatsThis" stdset="0">
-                                                        <string>Setup application</string>
+                                                        <string>Displays the
+                                                        command executed to
+                                                        setup the TAP
+                                                        interface.</string>
                                                     </property>
                                                 </widget>
@@ -608,5 +627,7 @@
                                                     </property>
                                                     <property name="whatsThis" stdset="0">
-                                                        <string>Select setup application</string>
+                                                        <string>Selects the
+                                                        setup
+                                                        application.</string>
                                                     </property>
                                                 </widget>
@@ -686,5 +707,8 @@
                                                     </property>
                                                     <property name="whatsThis" stdset="0">
-                                                        <string>Terminate application</string>
+                                                        <string>Displays the
+                                                        command executed to
+                                                        terminate the TAP
+                                                        interface.</string>
                                                     </property>
                                                 </widget>
@@ -697,5 +721,6 @@
                                                     </property>
                                                     <property name="whatsThis" stdset="0">
-                                                        <string>Select terminate application</string>
+                                                        <string>Selects the
+                                                        terminate application.</string>
                                                     </property>
                                                 </widget>
Index: /trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMNetworkSettings.ui.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMNetworkSettings.ui.h	(revision 1700)
+++ /trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMNetworkSettings.ui.h	(revision 1701)
@@ -51,7 +51,7 @@
         /* Setup Input layout */
         QHBoxLayout *inputLayout = new QHBoxLayout (mainLayout, 10, "inputLayout");
-        QLabel *lbName = new QLabel ("Interface Name", this);
+        QLabel *lbName = new QLabel (tr ("Interface Name"), this);
         mLeName = new QLineEdit (aIfaceName, this);
-        QWhatsThis::add (mLeName, tr ("Enter name for the interface to be created"));
+        QWhatsThis::add (mLeName, tr ("Descriptive name of the new network interface"));
         inputLayout->addWidget (lbName);
         inputLayout->addWidget (mLeName);
@@ -61,7 +61,7 @@
         /* Setup Button layout */
         QHBoxLayout *buttonLayout = new QHBoxLayout (mainLayout, 10, "buttonLayout");
-        mBtOk = new QPushButton ("OK", this, "btOk");
+        mBtOk = new QPushButton (tr ("&OK"), this, "mBtOk");
         QSpacerItem *spacer = new QSpacerItem(0, 0, QSizePolicy::Expanding, QSizePolicy::Minimum);
-        QPushButton *btCancel = new QPushButton ("Cancel", this, "btCancel");
+        QPushButton *btCancel = new QPushButton (tr ("Cancel"), this, "btCancel");
         connect (mBtOk, SIGNAL (clicked()), this, SLOT (accept()));
         connect (btCancel, SIGNAL (clicked()), this, SLOT (reject()));
@@ -129,4 +129,8 @@
     pbHostRemove->setIconSet (VBoxGlobal::iconSet ("remove_host_iface_16px.png",
                                                    "remove_host_iface_disabled_16px.png"));
+    /* setup languages */
+    QToolTip::add (pbHostAdd, tr ("Add"));
+    QToolTip::add (pbHostRemove, tr ("Remove"));
+    /* setup connections */
     connect (grbEnabled, SIGNAL (toggled (bool)),
              this, SLOT (grbEnabledToggled (bool)));
@@ -382,5 +386,5 @@
     /* creating add host interface dialog */
     VBoxAddNIDialog dlg (this, lbHostInterface->currentItem() != -1 ?
-                         tr ("Host Interface %1").arg (++mInterfaceNumber) :
+                         tr ("VirtualBox Host Interface %1").arg (++mInterfaceNumber) :
                          leHostInterfaceName->text());
     if (dlg.exec() != QDialog::Accepted)
@@ -429,9 +433,11 @@
     /* asking user about deleting selected network interface */
     int delNetIface = vboxProblem().message (this, VBoxProblemReporter::Question,
-        tr ("<p>Do you want to remove selected network interface "
+        tr ("<p>Do you want to remove the selected host network interface "
             "<nobr><b>%1</b>?</nobr></p>"
-            "<p>If this interface is currently selected you should "
-            "apply VM settings changes to avoid VM using of non-existing "
-            "interface</p>").arg (iName),
+            "<p><b>Note:</b> This interface may be in use by one or more "
+            "network adapters of this or another VM. After it is removed, these "
+            "adapters will no longer work until you correct their settings by "
+            "either choosing a differnet interface name or a different adapter "
+            "attachment type.</p>").arg (iName),
         0, /* autoConfirmId */
         QIMessageBox::Ok | QIMessageBox::Default,