Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_de.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_de.ts	(revision 1743)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_de.ts	(revision 1767)
@@ -1,3 +1,31 @@
 <!DOCTYPE TS><TS>
+<context>
+    <name>@@@</name>
+    <message>
+        <source>English</source>
+        <comment>Native language name</comment>
+        <translation>Deutsch</translation>
+    </message>
+    <message>
+        <source>built-in</source>
+        <comment>Native language country name (empty if this language is for all countries)</comment>
+        <translation></translation>
+    </message>
+    <message>
+        <source>English</source>
+        <comment>Language name, in English</comment>
+        <translation>German</translation>
+    </message>
+    <message>
+        <source>built-in</source>
+        <comment>Language country name, in English (empty if native country name is empty)</comment>
+        <translation></translation>
+    </message>
+    <message>
+        <source>InnoTek</source>
+        <comment>Comma-separated list of translators</comment>
+        <translation></translation>
+    </message>
+</context>
 <context>
     <name>BootItemsList</name>
@@ -1308,4 +1336,14 @@
         <comment>USBDeviceState</comment>
         <translation>gefangen</translation>
+    </message>
+    <message>
+        <source>&lt;i&gt;Checking...&lt;/i&gt;</source>
+        <comment>hard disk</comment>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <source>&lt;i&gt;Inaccessible&lt;/i&gt;</source>
+        <comment>hard disk</comment>
+        <translation type="unfinished"></translation>
     </message>
 </context>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ru.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ru.ts	(revision 1743)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_ru.ts	(revision 1767)
@@ -1,3 +1,31 @@
 <!DOCTYPE TS><TS>
+<context>
+    <name>@@@</name>
+    <message>
+        <source>English</source>
+        <comment>Native language name</comment>
+        <translation>Русский</translation>
+    </message>
+    <message>
+        <source>built-in</source>
+        <comment>Native language country name (empty if this language is for all countries)</comment>
+        <translation></translation>
+    </message>
+    <message>
+        <source>English</source>
+        <comment>Language name, in English</comment>
+        <translation>Russian</translation>
+    </message>
+    <message>
+        <source>built-in</source>
+        <comment>Language country name, in English (empty if native country name is empty)</comment>
+        <translation></translation>
+    </message>
+    <message>
+        <source>InnoTek</source>
+        <comment>Comma-separated list of translators</comment>
+        <translation></translation>
+    </message>
+</context>
 <context>
     <name>BootItemsList</name>
@@ -1303,4 +1331,14 @@
         <source>Captured</source>
         <comment>USBDeviceState</comment>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <source>&lt;i&gt;Checking...&lt;/i&gt;</source>
+        <comment>hard disk</comment>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <source>&lt;i&gt;Inaccessible&lt;/i&gt;</source>
+        <comment>hard disk</comment>
         <translation type="unfinished"></translation>
     </message>
Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_xx_YY.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_xx_YY.ts	(revision 1743)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_xx_YY.ts	(revision 1767)
@@ -1,3 +1,31 @@
 <!DOCTYPE TS><TS>
+<context>
+    <name>@@@</name>
+    <message>
+        <source>English</source>
+        <comment>Native language name</comment>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <source>built-in</source>
+        <comment>Native language country name (empty if this language is for all countries)</comment>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <source>English</source>
+        <comment>Language name, in English</comment>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <source>built-in</source>
+        <comment>Language country name, in English (empty if native country name is empty)</comment>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <source>InnoTek</source>
+        <comment>Comma-separated list of translators</comment>
+        <translation type="unfinished"></translation>
+    </message>
+</context>
 <context>
     <name>BootItemsList</name>
@@ -1303,4 +1331,14 @@
         <source>Captured</source>
         <comment>USBDeviceState</comment>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <source>&lt;i&gt;Checking...&lt;/i&gt;</source>
+        <comment>hard disk</comment>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <source>&lt;i&gt;Inaccessible&lt;/i&gt;</source>
+        <comment>hard disk</comment>
         <translation type="unfinished"></translation>
     </message>