Index: trunk/src/VBox/Runtime/r0drv/alloc-r0drv.h
===================================================================
--- trunk/src/VBox/Runtime/r0drv/alloc-r0drv.h	(revision 1460)
+++ trunk/src/VBox/Runtime/r0drv/alloc-r0drv.h	(revision 1816)
@@ -25,4 +25,5 @@
 #include <iprt/cdefs.h>
 #include <iprt/types.h>
+#include "internal/magics.h"
 
 __BEGIN_DECLS
@@ -43,6 +44,4 @@
 } RTMEMHDR, *PRTMEMHDR;
 
-/** Magic number for heap blocks. (Edgar Allan Poe) */
-#define RTMEMHDR_MAGIC      0x18090119
 
 /** @name RTMEMHDR::fFlags.
Index: trunk/src/VBox/Runtime/r0drv/darwin/semaphore-r0drv-darwin.cpp
===================================================================
--- trunk/src/VBox/Runtime/r0drv/darwin/semaphore-r0drv-darwin.cpp	(revision 1460)
+++ trunk/src/VBox/Runtime/r0drv/darwin/semaphore-r0drv-darwin.cpp	(revision 1816)
@@ -26,4 +26,5 @@
 *******************************************************************************/
 #include "the-darwin-kernel.h"
+
 #include <iprt/semaphore.h>
 #include <iprt/alloc.h>
@@ -31,4 +32,6 @@
 #include <iprt/asm.h>
 #include <iprt/err.h>
+
+#include "internal/magics.h"
 
 
@@ -53,7 +56,4 @@
 } RTSEMEVENTINTERNAL, *PRTSEMEVENTINTERNAL;
 
-/** Magic for the Darwin event semaphore structure. (Neil Gaiman) */
-#define RTSEMEVENT_MAGIC 0x19601110
-
 
 /**
@@ -74,7 +74,4 @@
 } RTSEMEVENTMULTIINTERNAL, *PRTSEMEVENTMULTIINTERNAL;
 
-/** Magic for the Darwin multiple release event semaphore structure. (Isaac Asimov) */
-#define RTSEMEVENTMULTI_MAGIC 0x19200102
-
 
 #if 0 /** @todo */
@@ -90,6 +87,4 @@
 } RTSEMMUTEXINTERNAL, *PRTSEMMUTEXINTERNAL;
 
-/** Magic for the Darwin mutex semaphore structure. (Douglas Adams) */
-#define RTSEMMUTEX_MAGIC 0x19520311
 #endif
 
@@ -106,6 +101,4 @@
 } RTSEMFASTMUTEXINTERNAL, *PRTSEMFASTMUTEXINTERNAL;
 
-/** Magic value for RTSEMFASTMUTEXINTERNAL::u32Magic (John Ronald Reuel Tolkien). */
-#define RTSEMFASTMUTEX_MAGIC    0x18920102
 
 
Index: trunk/src/VBox/Runtime/r0drv/darwin/spinlock-r0drv-darwin.cpp
===================================================================
--- trunk/src/VBox/Runtime/r0drv/darwin/spinlock-r0drv-darwin.cpp	(revision 1460)
+++ trunk/src/VBox/Runtime/r0drv/darwin/spinlock-r0drv-darwin.cpp	(revision 1816)
@@ -31,4 +31,6 @@
 #include <iprt/asm.h>
 
+#include "internal/magics.h"
+
 
 /*******************************************************************************
@@ -45,7 +47,4 @@
     lck_spin_t         *pSpinLock;
 } RTSPINLOCKINTERNAL, *PRTSPINLOCKINTERNAL;
-
-/** Magic value for RTSPINLOCKINTERNAL::u32Magic. (Terry Pratchett) */
-#define RTSPINLOCK_MAGIC    0x19480428
 
 
Index: trunk/src/VBox/Runtime/r0drv/linux/semaphore-r0drv-linux.c
===================================================================
--- trunk/src/VBox/Runtime/r0drv/linux/semaphore-r0drv-linux.c	(revision 1460)
+++ trunk/src/VBox/Runtime/r0drv/linux/semaphore-r0drv-linux.c	(revision 1816)
@@ -32,4 +32,6 @@
 #include <iprt/err.h>
 
+#include "internal/magics.h"
+
 
 /*******************************************************************************
@@ -48,7 +50,4 @@
     wait_queue_head_t   Head;
 } RTSEMEVENTINTERNAL, *PRTSEMEVENTINTERNAL;
-
-/** Magic for the Linux event semaphore structure. (Neil Gaiman) */
-#define RTSEMEVENT_MAGIC 0x19601110
 
 
@@ -68,7 +67,4 @@
 } RTSEMMUTEXINTERNAL, *PRTSEMMUTEXINTERNAL;
 
-/** Magic for the Linux mutex semaphore structure. (Douglas Adams) */
-#define RTSEMMUTEX_MAGIC 0x19520311
-
 
 /**
@@ -82,7 +78,4 @@
     struct semaphore    Semaphore;
 } RTSEMFASTMUTEXINTERNAL, *PRTSEMFASTMUTEXINTERNAL;
-
-/** Magic value for RTSEMFASTMUTEXINTERNAL::u32Magic (John Ronald Reuel Tolkien). */
-#define RTSEMFASTMUTEX_MAGIC    0x18920102
 
 
Index: trunk/src/VBox/Runtime/r0drv/linux/spinlock-r0drv-linux.c
===================================================================
--- trunk/src/VBox/Runtime/r0drv/linux/spinlock-r0drv-linux.c	(revision 1460)
+++ trunk/src/VBox/Runtime/r0drv/linux/spinlock-r0drv-linux.c	(revision 1816)
@@ -25,4 +25,5 @@
 *******************************************************************************/
 #include "the-linux-kernel.h"
+
 #include <iprt/spinlock.h>
 #include <iprt/err.h>
@@ -30,6 +31,8 @@
 #include <iprt/assert.h>
 #include <iprt/asm.h>
+#include "internal/magics.h"
 
-#include <linux/spinlock.h>
+#include <linux/spinlock.h> /** @todo why is this here and not in the-linux-kernel.h? */
+
 
 /*******************************************************************************
@@ -50,7 +53,4 @@
 #endif
 } RTSPINLOCKINTERNAL, *PRTSPINLOCKINTERNAL;
-
-/** Magic value for RTSPINLOCKINTERNAL::u32Magic. (Terry Pratchett) */
-#define RTSPINLOCK_MAGIC    0x19480428
 
 
Index: trunk/src/VBox/Runtime/r0drv/nt/semaphore-r0drv-nt.cpp
===================================================================
--- trunk/src/VBox/Runtime/r0drv/nt/semaphore-r0drv-nt.cpp	(revision 1460)
+++ trunk/src/VBox/Runtime/r0drv/nt/semaphore-r0drv-nt.cpp	(revision 1816)
@@ -32,4 +32,6 @@
 #include <iprt/err.h>
 
+#include "internal/magics.h"
+
 
 /*******************************************************************************
@@ -47,6 +49,4 @@
 } RTSEMEVENTINTERNAL, *PRTSEMEVENTINTERNAL;
 
-/** Magic for the NT event semaphore structure. (Neil Gaiman) */
-#define RTSEMEVENT_MAGIC 0x19601110
 
 
@@ -67,6 +67,4 @@
 } RTSEMMUTEXINTERNAL, *PRTSEMMUTEXINTERNAL;
 
-/** Magic for the NT mutex semaphore structure. (Douglas Adams) */
-#define RTSEMMUTEX_MAGIC 0x19520311
 
 
@@ -82,6 +80,4 @@
 } RTSEMFASTMUTEXINTERNAL, *PRTSEMFASTMUTEXINTERNAL;
 
-/** Magic value for RTSEMFASTMUTEXINTERNAL::u32Magic (John Ronald Reuel Tolkien). */
-#define RTSEMFASTMUTEX_MAGIC    0x18920102
 
 
Index: trunk/src/VBox/Runtime/r0drv/nt/spinlock-r0drv-nt.cpp
===================================================================
--- trunk/src/VBox/Runtime/r0drv/nt/spinlock-r0drv-nt.cpp	(revision 1460)
+++ trunk/src/VBox/Runtime/r0drv/nt/spinlock-r0drv-nt.cpp	(revision 1816)
@@ -25,4 +25,5 @@
 *******************************************************************************/
 #include "the-nt-kernel.h"
+
 #include <iprt/spinlock.h>
 #include <iprt/err.h>
@@ -30,4 +31,6 @@
 #include <iprt/assert.h>
 #include <iprt/asm.h>
+
+#include "internal/magics.h"
 
 
@@ -45,7 +48,4 @@
     KSPIN_LOCK          Spinlock;
 } RTSPINLOCKINTERNAL, *PRTSPINLOCKINTERNAL;
-
-/** Magic value for RTSPINLOCKINTERNAL::u32Magic. (Terry Pratchett) */
-#define RTSPINLOCK_MAGIC    0x19480428
 
 
Index: trunk/src/VBox/Runtime/r0drv/os2/semevent-r0drv-os2.cpp
===================================================================
--- trunk/src/VBox/Runtime/r0drv/os2/semevent-r0drv-os2.cpp	(revision 1460)
+++ trunk/src/VBox/Runtime/r0drv/os2/semevent-r0drv-os2.cpp	(revision 1816)
@@ -41,4 +41,6 @@
 #include <iprt/err.h>
 
+#include "internal/magics.h"
+
 
 /*******************************************************************************
@@ -61,7 +63,4 @@
     SpinLock_t          Spinlock;
 } RTSEMEVENTINTERNAL, *PRTSEMEVENTINTERNAL;
-
-/** Magic for the OS/2 event semaphore structure. (Neil Gaiman) */
-#define RTSEMEVENT_MAGIC 0x19601110
 
 
Index: trunk/src/VBox/Runtime/r0drv/os2/semeventmulti-r0drv-os2.cpp
===================================================================
--- trunk/src/VBox/Runtime/r0drv/os2/semeventmulti-r0drv-os2.cpp	(revision 1460)
+++ trunk/src/VBox/Runtime/r0drv/os2/semeventmulti-r0drv-os2.cpp	(revision 1816)
@@ -40,4 +40,5 @@
 #include <iprt/assert.h>
 #include <iprt/err.h>
+#include "internal/magics.h"
 
 
@@ -61,7 +62,4 @@
     SpinLock_t          Spinlock;
 } RTSEMEVENTMULTIINTERNAL, *PRTSEMEVENTMULTIINTERNAL;
-
-/** Magic for the OS/2 multiple release event semaphore structure. (Isaac Asimov) */
-#define RTSEMEVENTMULTI_MAGIC 0x19200102
 
 
Index: trunk/src/VBox/Runtime/r0drv/os2/semfastmutex-r0drv-os2.cpp
===================================================================
--- trunk/src/VBox/Runtime/r0drv/os2/semfastmutex-r0drv-os2.cpp	(revision 1460)
+++ trunk/src/VBox/Runtime/r0drv/os2/semfastmutex-r0drv-os2.cpp	(revision 1816)
@@ -40,4 +40,6 @@
 #include <iprt/asm.h>
 
+#include "internal/magics.h"
+
 
 /*******************************************************************************
@@ -54,9 +56,4 @@
     MutexLock_t         Mtx;
 } RTSEMFASTMUTEXINTERNAL, *PRTSEMFASTMUTEXINTERNAL;
-
-/** Magic value for RTSEMFASTMUTEXINTERNAL::u32Magic (John Ronald Reuel Tolkien). */
-#define RTSEMFASTMUTEX_MAGIC        0x18920102
-/** Dead magic value. */
-#define RTSEMFASTMUTEX_MAGIC_DEAD   0x0000000 /// @todo
 
 
Index: trunk/src/VBox/Runtime/r0drv/os2/spinlock-r0drv-os2.cpp
===================================================================
--- trunk/src/VBox/Runtime/r0drv/os2/spinlock-r0drv-os2.cpp	(revision 1460)
+++ trunk/src/VBox/Runtime/r0drv/os2/spinlock-r0drv-os2.cpp	(revision 1816)
@@ -40,4 +40,6 @@
 #include <iprt/asm.h>
 
+#include "internal/magics.h"
+
 
 /*******************************************************************************
@@ -54,8 +56,4 @@
     SpinLock_t          Spinlock;
 } RTSPINLOCKINTERNAL, *PRTSPINLOCKINTERNAL;
-
-/** Magic value for RTSPINLOCKINTERNAL::u32Magic. (Terry Pratchett) */
-#define RTSPINLOCK_MAGIC    0x19480428
-
 
 
Index: trunk/src/VBox/Runtime/r0drv/os2/timer-r0drv-os2.cpp
===================================================================
--- trunk/src/VBox/Runtime/r0drv/os2/timer-r0drv-os2.cpp	(revision 1460)
+++ trunk/src/VBox/Runtime/r0drv/os2/timer-r0drv-os2.cpp	(revision 1816)
@@ -42,4 +42,6 @@
 #include <iprt/assert.h>
 #include <iprt/alloc.h>
+
+#include "internal/magics.h"
 
 
@@ -79,7 +81,4 @@
 } RTTIMER;
 
-/** Magic number for timer handles. (Jared Mason Diamond) */
-#define RTTIMER_MAGIC       0x19370910
-
 
 /*******************************************************************************